import * as ColumnTypes from '../utilities/ColumnTypes'

const Folder: ColumnTypes.Model = {
  modelName: 'Folder',
  tableName: 'folders',
  options: {
    timestamps: true,
    paranoid: true,
    createdAt: 'createdAt',
    updatedAt: 'updatedAt',
    deletedAt: 'deletedAt',
  },
  attributes: {
    id: {
      allowNull: true,
      primaryKey: true,
      type: ColumnTypes.UUIDV4,
    },
    name: {
      allowNull: false,
      type: ColumnTypes.STRING,
    },
    parentId: {
      allowNull: true,
      type: ColumnTypes.UUIDV4,
    },
    createdAt: {
      allowNull: false,
      type: ColumnTypes.DATE,
    },
    updatedAt: {
      allowNull: false,
      type: ColumnTypes.DATE,
    },
    deletedAt: {
      allowNull: true,
      type: ColumnTypes.DATE,
    },
  }
}

export default Folder
